<?php
/**
 * Поиск внешних ссылок в заголовке и в тексте статьи
 * На входе функции: заголовок, текст
 * На выходе: false если ссылок нет, массив с ссылками если они есть в заголовке или тексте
 * ВАЖНО!!! Весь текст должен быть в кодировке UTF-8
*/

function findOutLinks($title, $content) {
    $out = array();

    $arr = array($title, $content);
    foreach ($arr as $str) {
        $str = mb_strtolower($str, 'utf-8');
        $offset = 0;
        while (($ps = mb_strpos($str, '<a ', $offset, 'utf-8')) !== false) {
            $offset = $ps + 3;
            $pe = mb_strpos($str, '</a>', $offset, 'utf-8');
            if ($pe === false) continue;

            $link = mb_substr($str, $ps, $pe + 4 - $ps, 'utf-8');
            $psl = mb_strpos($link, 'href="', 0, 'utf-8');
            if ($psl !== false) {
                $pel = mb_strpos($link, '"', $psl + 6, 'utf-8');
            } else {
                $psl = mb_strpos($link, "href='", 0, 'utf-8');
                if ($psl !== false) {
                    $pel = mb_strpos($link, "'", $psl + 6, 'utf-8');
                } else {
                    continue;
                }
            }
            $url = mb_substr($link, $psl + 6, $pel - $psl - 6, 'utf-8');
            if (mb_strpos($url, 'http://', 0, 'utf-8') === false && mb_strpos($url, 'https://', 0, 'utf-8') === false) continue;
            if (mb_strpos($url, '://www.sq.com.ua', 0, 'utf-8') !== false || mb_strpos($url, '://sq.com.ua', 0, 'utf-8') !== false) continue;

            // Bad URL
            $out[] = $url;
        }
    }

    return (!empty($out) ? $out : false);
}


$title = '...';
$content = '...';

$res = findOutLinks($title, $content);

